#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <string.h>


int main(int argc, char *argv[]){

    pid_t pid;

    int conditions[2]; // write = 1, read = 0
    pipe(conditions); // create a pipe

    pid = fork(); // duplicate the process

    if(pid == 0){
        /*child*/
        printf("Iam the child\n");

        int qsum = 0;
        for(int i = 0; i < strlen(argv[1]); i++){
            qsum += argv[1][i] - '0';
        }

        close(conditions[0]); // -> child wants to write
        write(conditions[1], &qsum, sizeof(qsum)); // -> write the qsum to the pipe
        close(conditions[1]); // -> close the writing

    }
    else if (pid != -1){
        /*parent*/
        printf("Iam the parent\n");

        int qsum = 0;
        close(conditions[1]);
        read(conditions[0], &qsum, sizeof(qsum));
        close(conditions[0]);

        printf("The qsum is: %d\n", qsum);
    }
    else {
        perror("Error while forking");
        return -1;
    }

    return 0;
}