#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <limits.h>
#include <sys/types.h>
#include <pwd.h>

int main(void){
    
    struct passwd *pwd;
    pwd = getpwuid(getuid());
    if(pwd == NULL){
        perror("getpwuid error");
        return -1;
    }
    printf("UID: %d\n", pwd->pw_uid);
    
    char *hostname = malloc((HOST_NAME_MAX + 1) * sizeof(char));
    if(gethostname(hostname, HOST_NAME_MAX) == -1){
        perror("gethostname error");
        free(hostname);
        return -1;
    }
    printf("HOST: %s\n", hostname);
    free(hostname);
    
    char *cwd =  malloc((PATH_MAX + 1)*sizeof(char));
    if(getcwd(cwd, PATH_MAX) == NULL){
        perror("getcwd error");
        free(cwd);
        return -1;
    }
    printf("CWD: %s\n", cwd);
    free(cwd);
    return 0;
}
